
// fx - A compositing library representation.

// Copyright (C) 2005-2006 VM Inc.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef FX_CONFIG_INC_
#define FX_CONFIG_INC_

#ifdef WIN32
#	ifdef FX_PLUGIN_EXPORTS
#		define FX_PLUGIN_DECLSPEC __declspec( dllexport )
#	else
#		define FX_PLUGIN_DECLSPEC __declspec( dllimport )
#	endif
#else
#	ifdef FX_PLUGIN_EXPORTS
#		define FX_PLUGIN_DECLSPEC extern
#	else
#		define FX_PLUGIN_DECLSPEC
#	endif 
#endif

#ifdef WIN32
#	ifdef FX_EXPORTS
#		define FX_DECLSPEC __declspec( dllexport )
#	else
#		define FX_DECLSPEC __declspec( dllimport )
#	endif // FX_EXPORTS
#else
#	define FX_DECLSPEC
#endif // WIN32

#ifndef OPENEFFECTSLIB_LIBNAME
#	define OPENEFFECTSLIB_LIBNAME "openeffectslib_fx"
#endif

#ifndef OPENEFFECTSLIB_TOOLSET
#	if defined( _MSC_VER ) && ( _MSC_VER == 1310 ) && !defined( __ICL )
#		define OPENEFFECTSLIB_TOOLSET "vc71"

#	elif defined( _MSC_VER ) && ( _MSC_VER >= 1400 )
#		define OPENEFFECTSLIB_TOOLSET "vc80"

#	elif defined( __ICL ) && ( __INTEL_COMPILER >= 900 )
#		define OPENEFFECTSLIBLIB_TOOLSET "iw90"
#	endif
#endif

#ifndef OPENEFFECTSLIB_DEBUG_SUFFIX
#	ifndef NDEBUG
#		define OPENEFFECTSLIB_DEBUG_SUFFIX "d"
#	else
#		define OPENEFFECTSLIB_DEBUG_SUFFIX "r"		
#	endif
#endif

#ifndef OPENEFFECTSLIB_VERSION
#	define OPENEFFECTSLIB_VERSION "0_3_0"
#endif

// library search record (auto link).
#if defined( WIN32 ) && !defined( OPENEFFECTSLIB_BUILD )
#	if defined( OPENEFFECTSLIB_LIBNAME ) && defined( OPENEFFECTSLIB_TOOLSET ) && defined( OPENEFFECTSLIB_DEBUG_SUFFIX ) && defined( OPENEFFECTSLIB_VERSION )
#		pragma comment( lib, OPENEFFECTSLIB_LIBNAME "-" OPENEFFECTSLIB_TOOLSET "-" OPENEFFECTSLIB_DEBUG_SUFFIX "-" OPENEFFECTSLIB_VERSION ".lib" )
#	endif
#endif

#endif
