
// fx - A compositing library representation.

// Copyright (C) 2005-2006 VM Inc.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef N_OPERATOR_AT_INC_
#define N_OPERATOR_AT_INC_

#if _MSC_VER
#pragma warning ( push )
#	pragma warning ( disable:4275 )
#endif

#include <openeffectslib/fx/n_operator.hpp>

namespace olib { namespace openeffectslib { namespace fx {

//
class FX_DECLSPEC n_operator_at : public fx::n_operator
{
public:
	typedef fx::n_operator::container		container;
	typedef fx::n_operator::param_container	param_container;

public:
	n_operator_at( );
	n_operator_at( const container& fields, const param_container& params );
	virtual ~n_operator_at( );

	virtual bool init( );
	virtual bool update_image( );
	virtual bool update_audio( );

	virtual bool dirty( ) const;
	virtual const fx::audio_buffer ab( ) const;
	virtual void bind_as_GL_texture( ) const;
	virtual void unbind_as_GL_texture( ) const;
	virtual GLuint get_GL_texture( ) const;
	virtual GLenum get_GL_target( ) const;
	virtual int width( ) const;
	virtual int height( ) const;
	virtual float max_s( ) const;
	virtual float max_t( ) const;

protected:
	virtual n_operator_ptr op_image( ) const = 0;
	virtual n_operator_ptr op_audio( ) const = 0;

private:
	static container empty_fields( ) 		{ container m; return m; }
	static param_container empty_params( ) 	{ param_container m; return m; }
};

} } }

#if _MSC_VER
#	pragma warning ( default:4275 )
#pragma warning ( pop )
#endif

#endif

