
// fx - A compositing library representation.

// Copyright (C) 2005-2006 VM Inc.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef N_OPERATOR_GPU_INC_
#define N_OPERATOR_GPU_INC_

#include <utility>

#include <openeffectslib/fx/n_operator.hpp>
#include <openeffectslib/fx/render_buffer.hpp>

namespace olib { namespace openeffectslib { namespace fx {

//
class FX_DECLSPEC n_operator_gpu : public n_operator
{
public:
	typedef std::pair<n_operator::container, n_operator::param_container>	creator_t;

protected:
	explicit n_operator_gpu( const container& fields, const param_container& params );
	explicit n_operator_gpu( const creator_t creator );
	n_operator_gpu( const n_operator_gpu& other );
	n_operator_gpu& operator=( const n_operator_gpu& other );
	void swap( n_operator_gpu& other );
	virtual ~n_operator_gpu( );

public:
	virtual bool update_image( ) { return false; }
	virtual bool update_audio( ) { return false; }

public:
	virtual const audio_buffer ab( ) 	 const  { return ab_; }
	virtual void bind_as_GL_texture( )   const	{ rb_.bind_as_GL_texture( ); }
	virtual void unbind_as_GL_texture( ) const	{ rb_.unbind_as_GL_texture( ); }
	virtual GLuint get_GL_texture( )	 const	{ return rb_.get_GL_texture( ); }
	virtual GLenum get_GL_target( )		 const	{ return rb_.get_GL_target( ); }
	virtual int width( )   const				{ return rb_.width( ); }
	virtual int height( )  const				{ return rb_.height( ); }
	virtual float max_s( ) const				{ return rb_.max_s( ); }
	virtual float max_t( ) const				{ return rb_.max_t( ); }
	
public:
	bool set_size( int new_w, int new_h );

protected:
	const render_buffer& rb( ) const { return rb_; }
	render_buffer&		 rb( )		 { return rb_; }
	void set_ab( audio_buffer ab )	 { ab_ = ab; }

private:
	render_buffer rb_;
	audio_buffer ab_;
};

} } }

#endif
