
// openpluginlib - An plugin interface to openlibraries.

// Copyright (C) 2005-2006 VM Inc.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef GL_UTILITY_INC_
#define GL_UTILITY_INC_

#ifdef HAVE_CONFIG_H
#include <openlibraries_global_config.hpp>
#endif

#include <GL/glew.h>

#include <utility>

#include <openpluginlib/pl/config.hpp>
#include <openpluginlib/pl/string.hpp>

namespace olib { namespace openpluginlib {

OPENPLUGINLIB_DECLSPEC std::pair<int, GLenum>	pf_to_gl_format( const wstring& pf );
OPENPLUGINLIB_DECLSPEC bool						is_compressed_format( const wstring& pf );
OPENPLUGINLIB_DECLSPEC bool						is_yuv_format( const wstring& pf );
OPENPLUGINLIB_DECLSPEC bool						texture_target( size_t width, size_t height, GLenum& target, float& tex_w, float& tex_h, bool force_2_0_targets = false );
OPENPLUGINLIB_DECLSPEC bool						proxy_texture_target( size_t width, size_t height, GLenum& target, bool force_2_0_targets = false );

} }

#endif
