
// openpluginlib - A plugin interface to openlibraries.

// Copyright (C) 2005-2006 VM Inc.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef PCOS_KEY_H
#define PCOS_KEY_H

#include <openpluginlib/pl/config.hpp>

// std
#include <vector>

namespace olib { namespace openpluginlib { namespace pcos {

/// A lightweight, comparable key to be used for 
/// properties
class OPENPLUGINLIB_DECLSPEC key
{
public:
    static key fromString( const char* );
    
    bool operator<( const key& ) const;
    bool operator==( const key& ) const;
    bool operator!=( const key& ) const;

private:
    friend std::ostream& operator<<( std::ostream&, const key& );

    key( std::size_t );
    
    std::size_t m_id;
};

typedef std::vector< key > key_vector;

std::ostream& operator<<( std::ostream&, const key& );

} } }

#endif // PCOS_KEY_H
